# Generated by Django 3.0.6 on 2020-05-10 21:18
from django.conf import settings
from django.db import migrations
import pandas as pd


def parse_schedule(cell, models, group):
    cell, *_ = cell.splitlines()
    for i, ch in enumerate(cell):
        ch: str
        if ch.isupper():
            cell = cell[i:]
            break

    for pair_type in ('Лекции', 'Практика', 'Лабораторные'):
        if pair_type in cell:
            subject, rest = map(str.strip, cell.split(pair_type))
            for i in range(len(rest) - 1, 0, -1):
                rest: str
                if rest[i].isspace() and rest[i - 1] != 'й':
                    if rest[i - 1].isdigit():
                        teacher = rest[:i - 2]
                        cabinet = rest[i - 2:]
                    else:
                        teacher = rest[:i]
                        cabinet = rest[i:]
                    teacher = teacher.strip()
                    cabinet = cabinet.strip()
                    break

            teacher = models.Teacher.objects.get(short_name=teacher[:-2] + ' ' + teacher[-2:])
            class_room, _ = models.ClassRoom.objects.get_or_create(name=cabinet)
            subject_obj, _ = models.Subject.objects.get_or_create(name=subject)
            return models.ScheduleItem(
                group=group,
                class_room=class_room,
                subject=subject_obj,
                teacher=teacher,
                type=pair_type,
            )
    else:
        print('Did not find type')


def get_schedule(df, models):
    schedule_items = []
    df = df.iloc[3:]
    current_column = 3
    day = None
    while True:
        data = df[current_column]
        day = data[3] or day
        if time := data[4]:
            for i, cell in data.iloc[2:].iteritems():
                try:
                    if cell and (schedule := parse_schedule(cell, models, models.Group.objects.get(
                            number=df[1][i].replace(' ', '')
                    ))):
                        schedule.time = time
                        schedule.day = day
                        schedule.week_number = df[2][i]
                        schedule_items.append(schedule)
                except (models.Group.DoesNotExist, models.Teacher.DoesNotExist, models.Subject.DoesNotExist) as e:
                    print(e)
        else:
            break
        current_column += 1
    return schedule_items


def fill_schedule_based(apps, schema_editor):
    class Models:
        Group = apps.get_model('spbstu', 'Group')
        Teacher = apps.get_model('spbstu', 'Teacher')
        Subject = apps.get_model('spbstu', 'Subject')
        ClassRoom = apps.get_model('spbstu', 'ClassRoom')
        ScheduleItem = apps.get_model('spbstu', 'ScheduleItem')

    schedule = []
    xl = pd.ExcelFile(settings.DB_EXCEL_DIR / 'Schedule.xlsx')
    for sheet in filter(lambda n: any(n.startswith(pattern) for pattern in ('бк', 'мг')), xl.sheet_names):
        df = xl.parse(sheet, header=None).fillna('')
        schedule.extend(get_schedule(df, Models))
    Models.ScheduleItem.objects.bulk_create(schedule)


def drop_schedule_based(apps, schema_editor):
    ScheduleItem = apps.get_model('spbstu', 'ScheduleItem')
    Subject = apps.get_model('spbstu', 'Subject')
    ClassRoom = apps.get_model('spbstu', 'ClassRoom')

    for model in (ScheduleItem, ClassRoom, Subject):
        model.objects.all().delete()


class Migration(migrations.Migration):
    dependencies = [
        ('spbstu', '0011_auto_20200511_0014'),
    ]

    operations = [
        migrations.RunPython(fill_schedule_based, drop_schedule_based)
    ]
